(* Title: BridgePIDE/user-model.sml
   Author: Walther Neuper 230214

This is a stub reminding of user requirements confirmed in Isac's field tests.
*)

signature USER_MODEL =
sig
  datatype show_spec = None | Model_Only | Model_Refs

\<^isac_test>\<open>
(**)
\<close>
end

(**)
structure User_Model(**) : USER_MODEL(**) =
struct
(**)

datatype show_spec =
  None       (* \<open>Specification\<close> is folded in and the specify phase is skippe               *)
| Model_Only (* \<open>Model\<close> is shown and \<open>References\<close> are folded in (data from Formalise.refs) *)
| Model_Refs (* the full \<open>Specification\<close> is displayed for a complete specify phase         *)

(**)end(*struct*);
